"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = initSharedStrings;
var _sanitizeText = _interopRequireDefault(require("../xml/sanitizeText.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function initSharedStrings() {
  var sharedStrings = [];
  var sharedStringsIndex = {};
  return {
    getSharedStrings: function getSharedStrings() {
      return sharedStrings;
    },
    getSharedString: function getSharedString(string) {
      var id = sharedStringsIndex[string];
      if (id === undefined) {
        id = String(sharedStrings.length);
        sharedStringsIndex[string] = id;
        sharedStrings.push(string);
      }
      return id;
    }
  };
}
//# sourceMappingURL=sharedStrings.js.map